/***************************************************************************
 *  GBAGI: The Game Boy Advance Adventure Game Interpreter
 *  Copyright (C) 2003,2004 Brian Provinciano, http://www.bripro.com
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ***************************************************************************/

/*****************************************************************************/
#include "makerom.h"
#include "commands.h"
/*****************************************************************************/

const AGITEST testCommands[MAX_TESTCMD] = {
	{"eval.z", "cEvalZ", 0, 0x00},
	{"equaln", "cEqualn", 2, 0x80},
	{"equalv", "cEqualv", 2, 0xC0},
	{"lessn", "cLessn", 2, 0x80},
	{"lessv", "cLessv", 2, 0xC0},
	{"greatern", "cGreatern", 2, 0x80},
	{"greaterv", "cGreaterv", 2, 0xC0},
	{"isset", "cIsset", 1, 0x00},
	{"issetv", "cIssetv", 1, 0x80},
	{"has", "cHas", 1, 0x00},
	{"obj.in.room", "cObjInRoom", 2, 0x40},
	{"posn", "cPosn", 5, 0x00},
	{"controller", "cController", 1, 0x00},
	{"have.key", "cHaveKey", 0, 0x00},
	{"said", "cSaid", 0, 0x00},
	{"compare.strings", "cCompareStrings", 2, 0x00},
	{"obj.in.box", "cObjInBox", 5, 0x00},
	{"center.posn", "cCenterPosn", 5, 0x00},
	{"right.posn", "cRightPosn", 5, 0x00},
};

const AGICMD agiCommands[MAX_AGICMD] = {
	{"return", "cReturn", 0, 0x00},
	{"increment", "cIncrement", 1, 0x80},
	{"decrement", "cDecrement", 1, 0x80},
	{"assignn", "cAssignn", 2, 0x80},
	{"assignv", "cAssignv", 2, 0xC0},
	{"addn", "cAddn", 2, 0x80},
	{"addv", "cAddv", 2, 0xC0},
	{"subn", "cSubn", 2, 0x80},
	{"subv", "cSubv", 2, 0xC0},
	{"lindirectv", "cLindirectv", 2, 0xC0},
	{"rindirect", "cRindirect", 2, 0xC0},
	{"lindirectn", "cLindirectn", 2, 0x80},
	{"set", "cSet", 1, 0x00},
	{"reset", "cReset", 1, 0x00},
	{"toggle", "cToggle", 1, 0x00},
	{"set.v", "cSetV", 1, 0x80},
	{"reset.v", "cResetV", 1, 0x80},
	{"toggle.v", "cToggleV", 1, 0x80},
	{"new.room", "cNewRoom", 1, 0x00},
	{"new.room.v", "cNewRoomV", 1, 0x80},
	{"load.logics", "cLoadLogics", 1, 0x00},
	{"load.logics.v", "cLoadLogicsV", 1, 0x80},
	{"call", "cCall", 1, 0x00},
	{"call.v", "cCallV", 1, 0x80},
	{"load.pic", "cLoadPic", 1, 0x80},
	{"draw.pic", "cDrawPic", 1, 0x80},
	{"show.pic", "cShowPic", 0, 0x00},
	{"discard.pic", "cDiscardPic", 1, 0x80},
	{"overlay.pic", "cOverlayPic", 1, 0x80},
	{"show.pri.screen", "cShowPriScreen", 0, 0x00},
	{"load.view", "cLoadView", 1, 0x00},
	{"load.view.v", "cLoadViewV", 1, 0x80},
	{"discard.view", "cDiscardView", 1, 0x00},
	{"animate.obj", "cAnimateObj", 1, 0x00},
	{"unanimate.all", "cUnanimateAll", 0, 0x00},
	{"draw", "cDraw", 1, 0x00},
	{"erase", "cErase", 1, 0x00},
	{"position", "cPosition", 3, 0x00},
	{"position.v", "cPositionV", 3, 0x60},
	{"get.posn", "cGetPosn", 3, 0x60},
	{"reposition", "cReposition", 3, 0x60},
	{"set.view", "cSetView", 2, 0x00},
	{"set.view.v", "cSetViewV", 2, 0x40},
	{"set.loop", "cSetLoop", 2, 0x00},
	{"set.loop.v", "cSetLoopV", 2, 0x40},
	{"fix.loop", "cFixLoop", 1, 0x00},
	{"release.loop", "cReleaseLoop", 1, 0x00},
	{"set.cel", "cSetCel", 2, 0x00},
	{"set.cel.v", "cSetCelV", 2, 0x40},
	{"last.cel", "cLastCel", 2, 0x40},
	{"current.cel", "cCurrentCel", 2, 0x40},
	{"current.loop", "cCurrentLoop", 2, 0x40},
	{"current.view", "cCurrentView", 2, 0x40},
	{"number.of.loops", "cNumberOfLoops", 2, 0x40},
	{"set.priority", "cSetPriority", 2, 0x00},
	{"set.priority.v", "cSetPriorityV", 2, 0x40},
	{"release.priority", "cReleasePriority", 1, 0x00},
	{"get.priority", "cGetPriority", 2, 0x40},
	{"stop.update", "cStopUpdate", 1, 0x00},
	{"start.update", "cStartUpdate", 1, 0x00},
	{"force.update", "cForceUpdate", 1, 0x00},
	{"ignore.horizon", "cIgnoreHorizon", 1, 0x00},
	{"observe.horizon", "cObserveHorizon", 1, 0x00},
	{"set.horizon", "cSetHorizon", 1, 0x00},
	{"object.on.water", "cObjectOnWater", 1, 0x00},
	{"object.on.land", "cObjectOnLand", 1, 0x00},
	{"object.on.anything", "cObjectOnAnything", 1, 0x00},
	{"ignore.objs", "cIgnoreObjs", 1, 0x00},
	{"observe.objs", "cObserveObjs", 1, 0x00},
	{"distance", "cDistance", 3, 0x20},
	{"stop.cycling", "cStopCycling", 1, 0x00},
	{"start.cycling", "cStartCycling", 1, 0x00},
	{"normal.cycle", "cNormalCycle", 1, 0x00},
	{"end.of.loop", "cEndOfLoop", 2, 0x00},
	{"reverse.cycle", "cReverseCycle", 1, 0x00},
	{"reverse.loop", "cReverseLoop", 2, 0x00},
	{"cycle.time", "cCycleTime", 2, 0x40},
	{"stop.motion", "cStopMotion", 1, 0x00},
	{"start.motion", "cStartMotion", 1, 0x00},
	{"step.size", "cStepSize", 2, 0x40},
	{"step.time", "cStepTime", 2, 0x40},
	{"move.obj", "cMoveObj", 5, 0x00},
	{"move.obj.v", "cMoveObjV", 5, 0x70},
	{"follow.ego", "cFollowEgo", 3, 0x00},
	{"wander", "cWander", 1, 0x00},
	{"normal.motion", "cNormalMotion", 1, 0x00},
	{"set.dir", "cSetDir", 2, 0x40},
	{"get.dir", "cGetDir", 2, 0x40},
	{"ignore.blocks", "cIgnoreBlocks", 1, 0x00},
	{"observe.blocks", "cObserveBlocks", 1, 0x00},
	{"block", "cBlock", 4, 0x00},
	{"unblock", "cUnblock", 0, 0x00},
	{"get", "cGet", 1, 0x00},
	{"get.v", "cGetV", 1, 0x80},
	{"drop", "cDrop", 1, 0x00},
	{"put", "cPut", 2, 0x00},
	{"put.v", "cPutV", 2, 0x40},
	{"get.room.v", "cGetRoomV", 2, 0xC0},
	{"load.sound", "cLoadSound", 1, 0x00},
	{"sound", "cSound", 2, 0x00},
	{"stop.sound", "cStopSound", 0, 0x00},
	{"print", "cPrint", 1, 0x00},
	{"print.v", "cPrintV", 1, 0x80},
	{"display", "cDisplay", 3, 0x00},
	{"display.v", "cDisplayV", 3, 0xE0},
	{"clear.lines", "cClearLines", 3, 0x00},
	{"text.screen", "cTextScreen", 0, 0x00},
	{"graphics", "cGraphics", 0, 0x00},
	{"set.cursor.char", "cSetCursorChar", 1, 0x00},
	{"set.text.attribute", "cSetTextAttribute", 2, 0x00},
	{"shake.screen", "cShakeScreen", 1, 0x00},
	{"configure.screen", "cConfigureScreen", 3, 0x00},
	{"status.line.on", "cStatusLineOn", 0, 0x00},
	{"status.line.off", "cStatusLineOff", 0, 0x00},
	{"set.string", "cSetString", 2, 0x00},
	{"get.string", "cGetString", 5, 0x00},
	{"word.to.string", "cWordToString", 2, 0x00},
	{"parse", "cParse", 1, 0x00},
	{"get.num", "cGetNum", 2, 0x40},
	{"prevent.input", "cPreventInput", 0, 0x00},
	{"accept.input", "cAcceptInput", 0, 0x00},
	{"set.key", "cSetKey", 3, 0x00},
	{"add.to.pic", "cAddToPic", 7, 0x00},
	{"add.to.pic.v", "cAddToPicV", 7, 0xFE},
	{"status", "cStatus", 0, 0x00},
	{"save.game", "cSaveGame", 0, 0x00},
	{"restore.game", "cRestoreGame", 0, 0x00},
	{"init.disk", "cInitDisk", 0, 0x00},
	{"restart.game", "cRestartGame", 0, 0x00},
	{"show.obj", "cShowObj", 1, 0x00},
	{"random", "cRandom", 3, 0x20},
	{"program.control", "cProgramControl", 0, 0x00},
	{"player.control", "cPlayerControl", 0, 0x00},
	{"obj.status.v", "cObjStatusV", 1, 0x80},
	{"quit", "cQuit", 1, 0x00},
	{"show.mem", "cShowMem", 0, 0x00},
	{"pause", "cPause", 0, 0x00},
	{"echo.line", "cEchoLine", 0, 0x00},
	{"cancel.line", "cCancelLine", 0, 0x00},
	{"init.joy", "cInitJoy", 0, 0x00},
	{"toggle.monitor", "cToggleMonitor", 0, 0x00},
	{"version", "cVersion", 0, 0x00},
	{"script.size", "cScriptSize", 1, 0x00},
	{"set.game.id", "cSetGameId", 1, 0x00},
	{"log", "cLog", 1, 0x00},
	{"set.scan.start", "cSetScanStart", 0, 0x00},
	{"reset.scan.start", "cResetScanStart", 0, 0x00},
	{"reposition.to", "cRepositionTo", 3, 0x00},
	{"reposition.to.v", "cRepositionToV", 3, 0x60},
	{"trace.on", "cTraceOn", 0, 0x00},
	{"trace.info", "cTraceInfo", 3, 0x00},
	{"print.at", "cPrintAt", 4, 0x00},
	{"print.at.v", "cPrintAtV", 4, 0x80},
	{"discard.view.v", "cDiscardViewV", 1, 0x80},
	{"clear.text.rect", "cClearTextRect", 5, 0x00},
	{"set.upper.left", "cSetUpperLeft", 2, 0x00},
	{"set.menu", "cSetMenu", 1, 0x00},
	{"set.menu.item", "cSetMenuItem", 2, 0x00},
	{"submit.menu", "cSubmitMenu", 0, 0x00},
	{"enable.item", "cEnableItem", 1, 0x00},
	{"disable.item", "cDisableItem", 1, 0x00},
	{"menu.input", "cMenuInput", 0, 0x00},
	{"show.obj.v", "cShowObjV", 1, 0x01},
	{"open.dialogue", "cOpenDialogue", 0, 0x00},
	{"close.dialogue", "cCloseDialogue", 0, 0x00},
	{"mul.n", "cMulN", 2, 0x80},
	{"mul.v", "cMulV", 2, 0xC0},
	{"div.n", "cDivN", 2, 0x80},
	{"div.v", "cDivV", 2, 0xC0},
	{"close.window", "cCloseWindow", 0, 0x00},
	{"unknown170", "cUnknown170", 1, 0x00},
	{"unknown171", "cUnknown171", 0, 0x00},
	{"unknown172", "cUnknown172", 0, 0x00},
	{"unknown173", "cUnknown173", 0, 0x00},
	{"unknown174", "cUnknown174", 1, 0x00},
	{"unknown175", "cUnknown175", 1, 0x00},
	{"unknown176", "cUnknown176", 0, 0x00},
	{"unknown177", "cUnknown177", 1, 0x00},
	{"unknown178", "cUnknown178", 0, 0x00},
	{"unknown179", "cUnknown179", 4, 0x00},
	{"unknown180", "cUnknown180", 2, 0x00},
	{"unknown181", "cUnknown181", 0, 0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{NULL,"InvalidBox",0,0x00},
	{"GOTO","ExecuteGoto",2,0x00},
	{"IF","ExecuteIF",0,0x00}
};

/*****************************************************************************/
